package jp.ne.xuni.selene;

import org.eclipse.ui.IMemento;

public class DirectSearchResult extends ZippedSearchResult {
	public static final String SEPARATOR = " -:- ";

	private int line;

	public DirectSearchResult() {
	}
	public DirectSearchResult(double weight, String host, String repository,
		String name, String archive, int line) {
		super(weight, host, repository, name, archive);
		this.line = line;
	}
	public DirectSearchResult(ZippedSearchResult sr, int line) {
		this(sr.getWeight(), sr.getHost(), sr.getRepository(), sr.getName(),
			sr.getArchive(), line);
	}
	public DirectSearchResult(double weight,
		String host, String repository, String name) {
		super(weight, host, repository, name);
		name = getName();

		int indexOfSeparator = name.lastIndexOf(SEPARATOR);
		if (indexOfSeparator != -1) {
			setName(name.substring(0, indexOfSeparator));
			line = Integer.parseInt(
				name.substring(indexOfSeparator + SEPARATOR.length()));
		}
	}

	public void setLine(int line) {
		this.line = line;
	}

	public int getLine() {
		return line;
	}

	public void saveState(IMemento memento) {
		super.saveState(memento);
		memento.putInteger("line", line);
	}

	public static DirectSearchResult createElement(IMemento memento) {
		return memento == null ? new DirectSearchResult() :
			new DirectSearchResult(ZippedSearchResult.createElement(memento),
			memento.getInteger("line"));
	}
}
