package jp.ne.xuni.selene;

import java.util.HashMap;

import jp.ne.xuni.selene.locators.SnippetLocator;
import jp.ne.xuni.seleneserver.ISeleneServer;

public class Index {
	public static final int TF = 0;
	public static final int DF = 1;

	private HashMap<String, int[]> index;

	public Index(String index) {
		String[][] indexArray =
			SnippetLocator.splitDocument(index, ISeleneServer.SEPARATOR);

		this.index = new HashMap<String, int[]>(indexArray.length);
		for (String[] termFreq : indexArray) {
			if (termFreq.length == 3) {
				this.index.put(termFreq[0], new int[] {
					Integer.parseInt(termFreq[1]),
					Integer.parseInt(termFreq[2]) });
			}
		}
	}

	public int getTf(String term) {
		return getFreq(term, TF);
	}
	public int getDf(String term) {
		return getFreq(term, DF);
	}
	public int getFreq(String term, int id) {
		int[] freqs = getFreqs(term);
		return freqs == null ? 0 : freqs[id];
	}
	public int[] getFreqs(String term) {
		return index.get(term);
	}
}
