package jp.ne.xuni.selene;

public class Query {
	public static final double DEFAULT_ATT_COEFF = 0.0;
	public static final double DEFAULT_THRESHOLD = 0.5;
	public static final int DEFAULT_BLOCK_SIZE = 20;

	private String document;
	private Index index;

	private int cursorPosition = 0;
	private double attCoeff = DEFAULT_ATT_COEFF;
	private double threshold = DEFAULT_THRESHOLD;
	private boolean lineWeighted = false;
	private int blockSize = DEFAULT_BLOCK_SIZE;
	private int blockOverlap = 0;

	public Query() {
	}
	public Query(double attCoeff, double threshold, boolean lineWeighted,
		int blockSize, int blockOverlap) {
		this.attCoeff = attCoeff;
		this.threshold = threshold;
		this.lineWeighted = lineWeighted;
		this.blockSize = blockSize;
		this.blockOverlap = blockOverlap;
	}

	public void setDocument(String document) {
		this.document = document;
	}
	public void setIndex(Index index) {
		this.index = index;
	}
	public void setCursorPosition(int cursorPosition) {
		this.cursorPosition = cursorPosition;
	}
	public void setAttCoeff(double attCoeff) {
		this.attCoeff = attCoeff;
	}
	public void setThreshold(double threshold) {
		this.threshold = threshold;
	}
	public void setLineWeighted(boolean lineWeighted) {
		this.lineWeighted = lineWeighted;
	}
	public void setBlockSize(int blockSize) {
		this.blockSize = blockSize;
	}
	public void setBlockOverlap(int blockOverlap) {
		this.blockOverlap = blockOverlap;
	}

	public String getDocument() {
		return document;
	}
	public Index getIndex() {
		return index;
	}
	public int getCursorPosition() {
		return cursorPosition;
	}
	public double getAttCoeff() {
		return attCoeff;
	}
	public double getThreshold() {
		return threshold;
	}
	public boolean isLineWeighted() {
		return lineWeighted;
	}
	public int getBlockSize() {
		return blockSize;
	}
	public int getBlockOverlap() {
		return blockOverlap;
	}

	public double lineWeight(int lineNumber) {
		int dist = Math.abs(lineNumber - cursorPosition);
		return 1.0 / (1.0 + attCoeff * dist);
	}
}
