package jp.ne.xuni.selene;

import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.IPersistable;

public class SearchResult implements IPersistable {
	private static final String DEFAULT_NAME = "Default.java";

	private double weight;
	private String host = SeleneClient.DEFAULT_HOST;
	private String repository = SeleneClient.DEFAULT_REPOSITORY;
	private String name = DEFAULT_NAME;

	public SearchResult() {
	}
	public SearchResult(double weight,
		String host, String repository, String name) {
		this.weight = weight;
		this.host = host;
		this.repository = repository;
		this.name = name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public double getWeight() {
		return weight;
	}
	public Path getPath() {
		return new Path(
			host + IPath.SEPARATOR + repository + IPath.SEPARATOR + name);
	}
	public String getHost() {
		return host;
	}
	public String getRepository() {
		return repository;
	}
	public String getName() {
		return name;
	}

	public void saveState(IMemento memento) {
		memento.putFloat("weight", (float)weight);
		memento.putString("host", host);
		memento.putString("repository", repository);
		memento.putString("name", name);
	}

	public static SearchResult createElement(IMemento memento) {
		return memento == null ? new SearchResult() :
			new SearchResult(memento.getFloat("weight"),
			memento.getString("host"), memento.getString("repository"),
			memento.getString("name"));
	}
}
