package jp.ne.xuni.selene;

import java.util.Enumeration;
import java.util.StringTokenizer;

public class Snippet extends FetchedDocument implements Enumeration<String> {
	public static final String DELIMITER = "\n";

	private int currentLine = 0;
	private int currentOffset = 0;
	private int sizeOfSnippet = Query.DEFAULT_BLOCK_SIZE;
	private StringTokenizer st;

	public Snippet(String document, SearchResult info) {
		super(document, info);
		st = new StringTokenizer(document, DELIMITER, true);
	}
	public Snippet(FetchedDocument fetched) {
		this(fetched.getDocument(), fetched.getInfo());
	}

	public void setCurrentLine(int position) {
		currentOffset = 0;
		st = new StringTokenizer(document, DELIMITER, true);
		for (currentLine = 0; st.hasMoreTokens() && currentLine < position;) {
			String str = st.nextToken();
			currentOffset += str.length();
			if (str.equals(DELIMITER)) {
				currentLine++;
			}
		}
	}

	public int getCurrentLine() {
		return currentLine;
	}
	public int getCurrentOffset() {
		return currentOffset;
	}

	public boolean hasMoreElements() {
		return st.hasMoreTokens();
	}
	public String nextElement() {
		int i;
		StringBuffer sb = new StringBuffer();
		for (i = 0; st.hasMoreTokens() && i < sizeOfSnippet;) {
			String str = st.nextToken();
			sb.append(str);
			currentOffset += str.length();
			if (str.equals(DELIMITER)) {
				i++;
			}
		}
		currentLine += i;
		return sb.toString();
	}
}
