package jp.ne.xuni.selene.evaluators;

import jp.ne.xuni.selene.SelenePlugin;
import jp.ne.xuni.selene.Snippet;
import jp.ne.xuni.selene.views.SeleneView;

import org.eclipse.jface.dialogs.IDialogSettings;

public abstract class SearchEvaluator implements Runnable {
	private static final String DS_ID = ".evaluators";

	protected SeleneView view;
	protected boolean printRecord;

	protected IDialogSettings ds = SelenePlugin.getDefault().
		getDialogSettings().getSection(SelenePlugin.PLUGIN_ID + DS_ID);
	{
		if (ds == null) {
			ds = SelenePlugin.getDefault().getDialogSettings().addNewSection(
				SelenePlugin.PLUGIN_ID + DS_ID);
		}
		printRecord = ds.getBoolean("printRecord");
	}

	public SearchEvaluator(SeleneView view) {
		this.view = view;
	}

	public abstract void evaluate(Snippet[] documents);
	public abstract void doNextSearch();

	public void run() {
		doNextSearch();
	}
}
