package jp.ne.xuni.selene.evaluators;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import jp.ne.xuni.selene.Snippet;
import jp.ne.xuni.selene.views.SeleneView;

public class SimpleEvaluator extends SearchEvaluator {
	private BufferedReader samples;
	{
		String samples = ds.get("samples");
		if (samples != null) {
			try {
				this.samples = new BufferedReader(new FileReader(samples));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}
	}

	public SimpleEvaluator(SeleneView view) {
		super(view);
	}

	public void evaluate(Snippet[] documents) {
		String record = "";
		for (Snippet document : documents) {
			record += document.getCurrentLine() + " ";
		}
		if (printRecord) System.out.println(record);
	}

	public void doNextSearch() {
		try {
			String sample;
			if ((sample = samples.readLine()) != null) {
				view.fetchDocument(sample);
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
