package jp.ne.xuni.selene.evaluators;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Vector;

import jp.ne.xuni.selene.Snippet;
import jp.ne.xuni.selene.locators.SnippetLocator;
import jp.ne.xuni.selene.views.SeleneView;

public class WordSetEvaluator extends SearchEvaluator {
	private HashSet<String> excludes = new HashSet<String>();
	private String[] blacklist = { "int", "string", "for", "while", "void",
			"public", "if", "else", "new", "args", "double", "float", "switch",
			"super", "protected", "static" };
	private StringBuilder file;
	private Vector<String> filenames = new Vector<String>();
	private FileReader fr;
	private BufferedReader br;
	private BufferedReader br2;
	private String answerfile;
	private String fnames = ds.get("murakami");
	private String foutnames = ds.get("murakami1");
	private boolean printout = ds.getBoolean("printout");
	private int l = 0;
	private int numofdoc;
	private FileWriter file1;
	private FileWriter file2;
	private PrintWriter pw;
	private PrintWriter pw2;

	public WordSetEvaluator(SeleneView view) throws IOException {
		super(view);
		for (String word : blacklist) {
			excludes.add(word);
		}

		file = new StringBuilder();
		getfilename();
		getwholefile();
		if (printout) {
			file1 = new FileWriter(foutnames + "data.txt");
			file2 = new FileWriter(foutnames + "data1.txt");
			pw = new PrintWriter(new BufferedWriter(file1));
			pw2 = new PrintWriter(new BufferedWriter(file2));
			pw.println(filenames.get(0));
			pw2.println(filenames.get(0));
			pw.println("line " + "score " + "filename " + "chosenline");
		}
		br = new BufferedReader(new FileReader(filenames.remove(0)));
	}

	private void getfilename() throws IOException {
		fr = new FileReader(fnames);
		br = new BufferedReader(fr);
		String tmp;
		while ((tmp = br.readLine()) != null) {
			filenames.add(tmp);
		}
		br.close();
	}

	private void getwholefile() throws IOException {
		br2 = new BufferedReader(new FileReader(filenames.get(0)));
		String tmp;
		while ((tmp = br2.readLine()) != null) {
			file.append(tmp);
			file.append("\n");
		}
		answerfile = file.toString();
		file.delete(0, file.length() - 1);
		file.setLength(0);
		br2.close();
	}

	public void evaluate(Snippet[] documents) {
		numofdoc = documents.length;
		for (int i = 1; i < documents.length; i++)
			compare(documents[0], documents[i], i);
	}

	public void doNextSearch() {
		int first = 9;
		try {
			String tmp_str;
			if (file.length() == 0) {
				while ((tmp_str = br.readLine()) != null && l <= first) {
					file.append(tmp_str);
					file.append("\n");
					l++;
				}
			} else {
				if ((tmp_str = br.readLine()) != null) {
					file.append(tmp_str);
					file.append("\n");
					l++;
				} else {
					br.close();
					file.delete(0, file.length() - 1);
					file.setLength(0);
					if (filenames.size() >= 2) {
						if (printout) {
							pw.close();
							pw2.close();
							file1 = new FileWriter(foutnames + "data.txt", true);
							file2 = new FileWriter(foutnames + "data1.txt",
									true);
							pw = new PrintWriter(new BufferedWriter(file1));
							pw2 = new PrintWriter(new BufferedWriter(file2));
							pw.println(filenames.get(0));
							pw2.println(filenames.get(0));
						}
						getwholefile();
						br = new BufferedReader(new FileReader(
								filenames.remove(0)));
						l = 0;
						while ((tmp_str = br.readLine()) != null && l <= first) {
							file.append(tmp_str);
							file.append("\n");
							l++;
						}
					} else {
						br.close();
						if (printout) {
							pw2.close();
							pw.close();
						}
					}
				}
			}
			view.openDocument(file.toString(), true, l - 1);
			view.doSearch();
		} catch (Exception e) {
			System.err.println("WordsetEvaluator error: " + e.getMessage());
		}
	}

	private void compare(Snippet file1, Snippet file2, int i) {
		int score = 0;
		int editlines = 15;
		int resultlines = 10;
		int editline = file1.getCurrentLine();
		int resultline = file2.getCurrentLine();
		String[][] editfile = SnippetLocator.splitDocument(answerfile);
		String[][] resultfile = SnippetLocator.splitDocument(file2
				.getDocument());
		HashMap<String, Integer> m1 = new HashMap<String, Integer>();
		HashMap<String, Integer> m2 = new HashMap<String, Integer>();
		HashSet<String> upperlines = new HashSet<String>();

		exclude(editfile, editline, upperlines);
		mapping(m1, editfile, editline, editlines, upperlines, 0);
		mapping(m2, resultfile, Math.max(0, resultline - 1), resultlines,
				upperlines, 1); // resultline-1:top line
		if (printRecord) {
			System.out.println("line : " + editline);
			System.out.println(m1.keySet());
			System.out.println(m2.keySet());
			System.out.println(scoring(m1, m2, score));
		}
		if (printout) {
			pw2.println(m1.keySet() + " " + m2.keySet());
			if (i == 1) {
				pw.print(editline + " ");
			}
			pw.print(scoring(m1, m2, score) + " " + file2.getName() + " "
					+ file2.getCurrentLine());
			pw.print(" :" + " ");
			if (i == numofdoc - 1) {
				pw.println();
			}
		}
	}

	private void exclude(String[][] file, int editline,
			HashSet<String> upperlines) {
		for (int i = 0; i < editline; i++) {
			for (String word : file[i]) {
				upperlines.add(word);
			}
		}
	}

	private void mapping(HashMap<String, Integer> m, String[][] file,
			int startline, int lines, HashSet<String> upperlines, int t) {
		for (int l = 0; l < lines; l++) {
			Integer k = lines - l;
			if (file.length > startline + l) {
				for (String word : file[startline + l]) {
					if (!excludes.contains(word) && !m.containsKey(word)
							&& (!upperlines.contains(word) || t == 1)) {
						m.put(word, k);
					}
				}
			}
		}
	}

	private int scoring(HashMap<String, Integer> m1,
			HashMap<String, Integer> m2, int score) {
		for (String key1 : m1.keySet()) {
			if (m2.containsKey(key1)) {
				score += m1.get(key1);
				// System.out.println(key1);
				// System.out.println(m1.get(key1));
			}
		}
		return score;
	}
}
