package jp.ne.xuni.selene.locators;


import java.util.*;

import jp.ne.xuni.selene.SearchResult;
import jp.ne.xuni.selene.Snippet;
import jp.ne.xuni.selene.Query;

public class AlignmentLocator extends SnippetLocator{
    
    public static int lines=9;

    public int locate(Query query, SearchResult result, Snippet snippet) {
	return chooseline(query.getDocument(), snippet.getDocument(), query.getCursorPosition());
    }

    public int chooseline(String file1, String file2, int cursorline){
	String[][] beingeditedfile = splitDocument(file1);
	String[][] recommendedfile = splitDocument(file2);
	int NumOfLines1=beingeditedfile.length;
	int NumOfLines2=recommendedfile.length;
	int[] rk = new int[NumOfLines2-lines+1];
		
	for(int m=0; m<NumOfLines2-lines; m++){
	    rk[m]=alignment(beingeditedfile, recommendedfile, m, cursorline);

	}
	int rank=rk[0];
	int ln=0;
	for(int m=1; m<NumOfLines2-lines; m++){
	    if(rank<=rk[m]){
		rank=rk[m];
		ln = m;  
		//	    System.out.println(rank);
	    }
	}
	if(debugLevel==1){
	System.out.println("Top Score: "+rank);
	System.out.println("Selected Lines: "+(ln)+" - "+(ln+lines)); 
	}
	
	return (ln+lines); 
    }
    
    public static int alignment(String[][] file1, String[][] file2, int m, int cursorline){
	int p=0;
	int gap = -1;
	int point = 2;
	int s,t;
	
	Vector<String> string1 = new Vector<String>();
	Vector<String> string2 = new Vector<String>();
	
	if(cursorline-lines>=0){
	    for(int l=cursorline-lines; l<=cursorline; l++){
	    	for(int j=0; j<file1[l].length; j++){
		    string1.add(file1[l][j]);
		}
	    }
	}
	else{
	    for(int l=0; l<=cursorline; l++){
	    	for(int j=0; j<file1[l].length; j++){
		    string1.add(file1[l][j]);
		    j++;
	    	}
	    }
	}
	
	for(int l=m; l<=m+lines; l++){
	    for(int j=0; j<file2[l].length; j++){
		string2.add(file2[l][j]);
	    }
			}
	
	s = string1.size();
	t = string2.size();
	int[][] score = new int[s][t];
	for (int i=0; i<s ; i++){
	    score[i][0] = gap*(i);
	}
	for (int j=0; j<t ; j++){
	    score[0][j] = gap*(j);
	}
	
	for (int i=1; i<s; i++){
	    for (int j=1; j<t; j++){
		if((string1.get(i-1)).equals(string2.get(j-1)))
		    p=point;
		else
		p=-1*point;
		
		score[i][j]=Math.max(
				     Math.max((score[i-1][j]+gap), (score[i-1][j-1]+p)),
				     (score[i][j-1]+gap));
		
	    }
	}
	return score[s-1][t-1];
    }
    
}


